#include "systick_timer.h"
#include "ch32v20x.h"

void Systick_Init()
{
    SysTick->CTLR = 0x00000000;             //ƼĴλ
    SysTick->SR = 0x00000000;               //״̬Ĵλ
    SysTick->CNT = 0x00000000;              //λóʼֵΪ0
    SysTick->CMP = 0xFFFFFFFF;              //ؼؼĴֵ
    SysTick->CTLR |= 0x00000029;            //ϵͳSTKHCLK/8ʱ ϼԶװ
}

unsigned int SysTick_CNT()
{
    return SysTick->CNT;
}

void Delay_500ns()
{
    unsigned int record_time = SysTick->CNT;
    unsigned int now;
    while(1)
    {
        now = SysTick->CNT;
        if((now > record_time) && ((now-record_time)/9)) break;
        else if((now < record_time) && ((0xFFFFFFFF-record_time+now)/9)) break;
    }
}

void Delay_us(unsigned int us)
{
    unsigned int record_time = SysTick->CNT;
    unsigned int now;
    while(1)
    {
        now = SysTick->CNT;
        if((now > record_time) && ((now-record_time)/18 >= us)) break;
        else if((now < record_time) && ((0xFFFFFFFF-record_time+now)/18 >= us)) break;
    }
}

void Delay(unsigned int ms)
{
    Delay_us(1000*ms);
}

void Timer_Begin(Timer *timer, unsigned int wait_time)
{
    timer->begin_time = SysTick->CNT;
    timer->wait_time = wait_time*18000;
    timer->status = 1;
}

int Timer_Current(Timer timer)
{
    unsigned int difference;
    unsigned int systick = SysTick->CNT;
    if(systick >= timer.begin_time) difference = systick-timer.begin_time;
    else difference = 0xFFFFFFFF-timer.begin_time+systick;
    return difference/18000.0+0.5;
}

//ȡǰﵽ趨ʱûλms
unsigned char Timer_Flag(Timer timer)
{
    unsigned int difference;
    unsigned int systick = SysTick->CNT;
    if(systick >= timer.begin_time) difference = systick-timer.begin_time;
    else difference = 0xFFFFFFFF-timer.begin_time+systick;
    if(difference >= timer.wait_time && timer.status) return 1;
    return 0;
}

void Timer_Cancel(Timer *timer)
{
    timer->status = 0;
}
